﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Security.Cryptography;
using System.Threading;
using System.IO;
using System.Threading.Tasks;
using System.IO;
using System.Data;
using System.Data.OleDb;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        #region  Globals
        int m, n;
        Boolean useDb = true,useStategy=true;
        OleDbConnection oleCon;
        OleDbCommand oleCom;
        OleDbDataAdapter oleda;
        OleDbDataReader oledr;
        Bitmap bmp, colbmp, rowbmp;
        Graphics g, rowg, colg;
        double ep = 0.00000001;
        int width = 0, height = 0;
        int Xresolution, Yresolution;
        int step = 10;
        int numPoints = 0;
        int numRedPoints = 0, numBluePoints = 0;
        Dictionary<Point, int> pointList;
        List<Point> redPoints;
        double[,] points, points2;
        double bluesShare, redsShare;
        SolidBrush blackBrush = new SolidBrush(Color.Black);
        SolidBrush whiteBrush = new SolidBrush(Color.White);
        Random random = new Random();
        SolidBrush blackbrush = new SolidBrush(Color.Black);
        SolidBrush vertBrush = new SolidBrush(Color.Black);
        SolidBrush horzBrush = new SolidBrush(Color.Blue);
        Pen blackPen = new Pen(Color.Black,2);
        Pen blackdashPen = new Pen(Color.Black, 1);
        

        public Form1()
        {
            InitializeComponent();
            
            oleCon = new OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0;Data Source=vgdb.mdb;Persist Security Info=True");
            oleCom = new OleDbCommand();
            oleCom.Connection = oleCon;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            bluesShare = redsShare = 0;
            
            pointList = new Dictionary<Point, int>();
            bmp = new Bitmap(pictureBox1.Width, pictureBox1.Height);
            colbmp = new Bitmap(colPicBox.Width, colPicBox.Height);
            rowbmp = new Bitmap(rowPicBox.Width, rowPicBox.Height);
            Xresolution = pictureBox1.Width;
            Yresolution = pictureBox1.Height;
            g = Graphics.FromImage(bmp);
            redPoints = new List<Point>();

            pictureBox1.Image = bmp;
            colg = Graphics.FromImage(colbmp);
            rowg = Graphics.FromImage(rowbmp);

            colPicBox.Image = colbmp;

            rowPicBox.Image = rowbmp;
        }

        #endregion

        #region Diagram
        
        private void draw()
        {
            GridVoronoiGame.diagram dg = new GridVoronoiGame.diagram();
            int startM = 5, endM = 7, Nprogress = 0;
            if (txtStartM.Text.Length == 0)
                startM = 5;
            else
                startM = int.Parse(txtStartM.Text);

            if (txtEndM.Text.Length == 0)
                endM = 7;
            else
                endM = int.Parse(txtEndM.Text);

            if (txtNPR.Text.Length == 0)
                Nprogress = 5;
            else
                Nprogress = int.Parse(txtNPR.Text);

            if (txtNumPoints.Text.Length == 0)
                numPoints = 1;
            else
                numPoints = int.Parse(txtNumPoints.Text);

            
            Dictionary<double[],double[]> dic = new Dictionary<double[],double[]>();
            
            oleCon.Open();
            Parallel.For(startM, endM+1, mCounter =>
                {
                    if (mCounter % 2 != 0)
                    {
                        double redsShare, bluesShare;
                        int m = mCounter;
                        int n=0;
                        double[] narr = new double[Nprogress];
                        double[] vals = new double[narr.Length];
                        int start = m * numPoints - numPoints + 1;
                        int celly = 0, cellx = m / 2;
                        int n1 = 0;
                        int n2 = 0;
                        int temp = 0;
                        String sqlStr = String.Format("SELECT n,bmr FROM Table1 WHERE k={0} and m={1} and (n>={2} and n<={3}) ORDER BY n", numPoints.ToString(), m.ToString(), start, start + Nprogress - 1);
                        OleDbCommand oleCom = new OleDbCommand();
                        oleCom.Connection = oleCon;
                        oleCom.CommandText = sqlStr;
                        OleDbDataReader oledr = oleCom.ExecuteReader();

                        if (oledr.HasRows)
                        {
                            oledr.Read();

                            n1 = int.Parse(oledr[0].ToString()) - start;
                            temp = int.Parse(oledr["n"].ToString());
                            narr[temp - start] = temp;
                            vals[temp - start] = double.Parse(oledr["bmr"].ToString());
                            n2 = n1 + 1;
                            while (oledr.Read())
                            {
                                temp = int.Parse(oledr["n"].ToString());
                                narr[temp - start] = temp;
                                vals[temp - start] = double.Parse(oledr["bmr"].ToString());
                                n2++;
                            }
                        }
                        else
                        {
                            n1 = Nprogress;
                            n2 = Nprogress + 1;
                        }
                        oledr.Close();

                        for (int i = 0; i < n1; i++)
                        {
                            narr[i] = start;
                            n = (int)narr[i];

                            vals[i] = findFirstWinPlacementsLimited2ForDiagram(m,n,out redsShare,out bluesShare);
                            sqlStr = String.Format("INSERT INTO Table1 (m,n,k,redsShare,bluesShare,bmr) VALUES ({0},{1},{2},{3},{4},{5})", m.ToString(), n.ToString(), numPoints.ToString(), 0, 0, vals[i].ToString());
                            oleCom.CommandText = sqlStr;
                            oleCom.ExecuteNonQuery();
                            start++;
                        }
                        start += n2;
                        for (int i = n2; i < narr.Length; i++)
                        {
                            narr[i] = start;
                            n = (int)narr[i];



                            
                            vals[i] = findFirstWinPlacementsLimited2ForDiagram(m,n,out redsShare,out bluesShare);
                            sqlStr = String.Format("INSERT INTO Table1 (m,n,k,redsShare,bluesShare,bmr) VALUES ({0},{1},{2},{3},{4},{5})", m.ToString(), n.ToString(), numPoints.ToString(), 0, 0, vals[i].ToString());
                            oleCom.CommandText = sqlStr;
                            oleCom.ExecuteNonQuery();
                            start++;
                        }

                        dic.Add(narr,vals);
                        
                    }
                });

            dg.Draw(dic);
            oleCon.Close();

            dg.ShowDialog();

        }

        public double findFirstWinPlacementsLimited2ForDiagram(int m, int n, out double redsShare, out double bluesShare)    //object sender, DoWorkEventArgs e
        {

            int i = 0;
            int celly = 0, cellx = m / 2;
            int numRedPoints = 0, numBluePoints = 0;
            double[,] points = new double[n, m];
            Dictionary<Point, int> pointList = new Dictionary<Point, int>();
            pointList.Clear();

            for (i = 1; i <= numPoints; i++)
            {
                celly = (int)Math.Floor((double)n / (2 * numPoints) + (double)(i - 1) * n / numPoints);
                points[celly, cellx] = -1;
                pointList.Add(new Point(celly, cellx), -1);
                numBluePoints++;
            }

            VoronoiRegionSimplified(points, pointList, m, n, out redsShare, out bluesShare);


            int[] pos = new int[numPoints];
            int[] posOr = new int[numPoints];
            double bestRed = 0, bestBlue = 0;
            int[] posInd = new int[numPoints];

            int j;
            int k = pointList.Count;
            double minDiff = m * n + 1;
            Dictionary<Point, int> d = new Dictionary<Point, int>();
            i = 1;
            bool NoSol = true;
            int t = 0, v = 0, p = 0;
            p = pos.Length - 1;

            double[,] points2 = new double[n, m];
            for (i = 0; i < n; i++)
                for (j = 0; j < m; j++)
                    points2[i, j] = points[i, j];

            int[] shifts = new int[9];

            shifts[0] = -(m - 3 + 4);
            shifts[1] = shifts[0] + 1;
            shifts[2] = shifts[0] + 2;
            shifts[3] = -1;
            shifts[4] = 1;
            shifts[5] = m - 3 + 2;
            shifts[6] = shifts[5] + 1;
            shifts[7] = shifts[6] + 1;
            shifts[8] = 0;
            
            redsShare = 0;
            bluesShare = 0;
            for (i = 0; i < numPoints; i++)
            {
                d.Add(pointList.Keys.ElementAt(i), -1);
            }

            for (i = 0; i < numPoints; i++)
            {
                posInd[i] = 0;
                Point pointi = d.Keys.ElementAt(i);
                posOr[i] = pointi.X * m + pointi.Y;
                pos[i] = posOr[i] + shifts[posInd[i]];
            }

            long counter = 0;

            while (true)
            {
                d.Clear();

                for (i = 0; i < numPoints; i++)
                {
                    d.Add(pointList.Keys.ElementAt(i), -1);
                }

                for (i = 0; i < numPoints; i++)
                {
                    d.Add(new Point((int)pos[i] / m, pos[i] % m), -2);
                    points2[(int)pos[i] / m, pos[i] % m] = -2;
                }

                redsShare = 0;
                bluesShare = 0;
                numRedPoints = k;
                VoronoiRegionSimplified(points2, d, m, n, out redsShare, out bluesShare);

                if (bluesShare - redsShare < minDiff)
                {
                    minDiff = bluesShare - redsShare;
                    bestRed = redsShare;
                    bestBlue = bluesShare;
                }
                if (redsShare > bluesShare)
                {
                    NoSol = false;
                }

                if (Math.Abs(bluesShare - redsShare) < ep)
                {
                    NoSol = false;
            
                }

                for (i = 0; i < numPoints; i++)
                {
                    points2[(int)pos[i] / m, pos[i] % m] = 0;
                }


                t = p;
                posInd[t]++;
                if (posInd[t] > 7)
                {

                    while (posInd[t] > 7 && t > 0)
                    {
                        pos[t] = posOr[t] + shifts[0];
                        posInd[t] = 0;
                        t--;
                        posInd[t]++;
                        pos[t] = posOr[t] + shifts[posInd[t]];
                    }

                    if (posInd[0] == 8)
                        break;
                }
                else
                {
                    
                    pos[t] = posOr[t] + shifts[posInd[t]];
                }

            }
            
            

            if (NoSol)
            {
                redsShare = bestRed;
                bluesShare = bestBlue;
            }
            numRedPoints = 0;
            return bestBlue - bestRed;
        }

        #endregion

        #region Manual

        private void CreateGrid()
        {
            if (txtM.Text.Length == 0)
                m = 1;
            else
                m = int.Parse(txtM.Text);

            if (txtN.Text.Length == 0)
                n = 1;
            else
                n = int.Parse(txtN.Text);

            if (txtNumPoints.Text.Length == 0)
                numPoints = 1;
            else
                numPoints = int.Parse(txtNumPoints.Text);

            if (m == 0)
                m = 1;
            if (n == 0)
                n = 1;


            numRedPoints = numBluePoints = 0;
            points = new double[n, m];
            points2 = new double[n, m];
            pointList.Clear();

            g.Clear(Color.White);
            colg.Clear(Color.LightGray);
            rowg.Clear(Color.LightGray);

            if (n > m)
            {
                step = (int)(Yresolution / (n));
            }
            else
            {
                step = (int)(Xresolution / (m));
            }

            height = step * (n);
            width = step * (m);

            int i;
            for (i = 0; i < n; i++)
                colg.DrawString((i + 1).ToString(), this.Font, blackbrush, new Point(1, i * step + this.Font.Height / 2));

            for (i = 0; i < m; i++)
                rowg.DrawString((i + 1).ToString(), this.Font, blackbrush, new Point(i * step + 2, this.Font.Height / 2));


            for (i = 0; i <= m; i++)
                g.DrawLine(blackPen, i * step, 0, i * step, height);

            for (i = 0; i <= n; i++)
                g.DrawLine(blackPen, 0, 0 + i * step, width, i * step);

            this.Refresh();

        }

        private void btnCreateGrid_Click(object sender, EventArgs e)
        {
            CreateGrid();
        }



        private void pictureBox1_MouseDown(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Left)
            {
                if (numBluePoints >= numPoints)
                    return;
                int x = e.X;
                int y = e.Y;

                if (x >= 0 && y >= 0 && x < m * step && y < n * step)
                {
                    int cellx = (int)(x / step);
                    int celly = (int)(y / step);
                    if (points[celly, cellx] < 0) return;

                    if (cellx >= 0 && cellx < m && celly >= 0 && celly < n)
                    {
                        points[celly, cellx] = -1;
                        g.FillRectangle(whiteBrush, cellx * step, celly * step, step, step);
                        g.DrawEllipse(blackPen, cellx * step + 4, celly * step + 4, step - 10, step - 10);
                        pointList.Add(new Point(celly, cellx), -1);
                        VoronoiRegion(points, pointList, m, n, out redsShare, out bluesShare);
                        numBluePoints++;
                        lblMinDiff.Text = (bluesShare - redsShare).ToString();
                    }
                }
            }

            else if (e.Button == MouseButtons.Right)
            {

                if (numRedPoints >= numPoints)
                    return;
                int x = e.X;
                int y = e.Y;

                if (x >= 0 && y >= 0 && x < m * step && y < n * step)
                {
                    int cellx = (int)(x / step);
                    int celly = (int)(y / step);
                    if (points[celly, cellx] < 0) return;

                    if (cellx >= 0 && cellx < m && celly >= 0 && celly < n)
                    {
                        points[celly, cellx] = -2;

                        g.FillRectangle(whiteBrush, cellx * step + 2, celly * step + 2, step - 2, step - 2);
                        g.FillEllipse(blackBrush, cellx * step + 4, celly * step + 4, step - 10, step - 10);
                        pointList.Add(new Point(celly, cellx), -2);
                        numRedPoints++;
                        VoronoiRegion(points, pointList, m, n, out redsShare, out bluesShare);
                        lblMinDiff.Text = (bluesShare - redsShare).ToString();
                    }
                }
            }

            this.Refresh();

        }

        private void pictureBox1_MouseDoubleClick(object sender, MouseEventArgs e)
        {
            
            int x = e.X;
            int y = e.Y;

            if (x >= 0 && y >= 0 && x < m * step && y < n * step)
            {
                int cellx = (int)(x / step);
                int celly = (int)(y / step);
                
                if (points[celly, cellx] >-2) return;
                
                if (cellx >= 0 && cellx < m && celly >= 0 && celly < n)
                {
                    points[celly, cellx] = 0;

                    g.FillRectangle(whiteBrush, cellx * step + 2, celly * step + 2, step - 2, step - 2);
                    pointList.Remove(new Point(celly, cellx));
                    numRedPoints--;
                    VoronoiRegion(points, pointList, m, n, out redsShare, out bluesShare);
                    lblMinDiff.Text = (bluesShare - redsShare).ToString();
                }
            }
            pictureBox1.Refresh();
        }


        #endregion

        #region Theory
        public void VoronoiRegion(double[,] points, Dictionary<Point, int> pointList,int m,int n,out double redsShare,out double bluesShare)
        {
            Point p;
            int i = 0, j = 0, k = 0;
            redsShare = bluesShare = 0;
            int drShare = 0;
            List<int> lst = new List<int>();
            for (i = 0; i < n; i++)
            {
                for (j = 0; j < m; j++)
                {

                    if (points[i, j] >= 0)
                    {
                        lst.Clear();
                        int minDist = m * n + 1;
                        for (k = 0; k < pointList.Count; k++)
                        {
                            p = pointList.Keys.ElementAt(k);
                            int dist = manhattanDistance(p, i, j);
                            if (dist < minDist)
                            {
                                minDist = dist;
                            }
                        }


                        for (k = 0; k < pointList.Count; k++)
                        {
                            p = pointList.Keys.ElementAt(k);
                            int dist = manhattanDistance(p, i, j);
                            if (dist == minDist)
                            {
                                lst.Add(k);
                            }
                        }

                        int redNearsCount = 0;
                        int blueNearCounts = 0;
                        for (k = 0; k < lst.Count; k++)
                        {
                            if (pointList.Values.ElementAt(lst.ElementAt(k)) == -1)
                                blueNearCounts++;
                            else
                                redNearsCount++;
                        }

                        points[i, j] = (double)blueNearCounts / (blueNearCounts + redNearsCount);
                        bluesShare += points[i, j];
                        redsShare += (1 - points[i, j]);
                        drShare = (int)(points[i, j] * step);
                        
                        g.FillRectangle(whiteBrush, j * step, i * step, step, step);
                        if (redNearsCount > 0 && blueNearCounts > 0)
                        {
                            g.DrawRectangle(blackdashPen, j * step + 2, i * step + 2, drShare - 4, step - 5);
                            g.FillRectangle(blackBrush, j * step + drShare, i * step + 2, step - drShare - 2, step - 4);
                        }
                        else
                        {
                            g.DrawRectangle(blackdashPen, j * step + 2, i * step + 2, drShare - 5, step - 5);
                            g.FillRectangle(blackBrush, j * step + drShare + 2, i * step + 2, step - drShare - 4, step - 4);
                        }
                    }
                }
            }

            for (k = 0; k < pointList.Count; k++)
            {
                if (pointList.Values.ElementAt(k) == -1)
                    bluesShare += 1;
                else
                    redsShare += 1;
            }


            for (i = 0; i <= m; i++)
                g.DrawLine(blackPen, i * step, 0, i * step, height);

            for (i = 0; i <= n; i++)
                g.DrawLine(blackPen, 0, 0 + i * step, width, i * step);
            label4.Text = redsShare.ToString();
            label3.Text = bluesShare.ToString();
            label10.Text = (redsShare == bluesShare).ToString();
            redsShare = Math.Round(redsShare, 10);
            bluesShare = Math.Round(bluesShare, 10);

        }

        public void VoronoiRegionSimplified(double[,] points, Dictionary<Point, int> pointList,int m,int n,out double redsShare,out double bluesShare)
        {
            
            redsShare = bluesShare = 0;
            int drShare = 0;
            double[] tmpRed = new double[n];
            double[] tmpBlue = new double[n];
            Parallel.For(0, n, i =>
            //for (i = 0; i < n; i++)
            {
                int j = 0;
                for (j = 0; j < m; j++)
                {
                    Point p;
                    List<int> lst = new List<int>();
                    int k;
                    if (points[i, j] >= 0)
                    {
                        lst.Clear();
                        int minDist = m * n + 1;
                        for (k = 0; k < pointList.Count; k++)
                        {
                            p = pointList.Keys.ElementAt(k);
                            int dist = manhattanDistance(p, i, j);
                            if (dist < minDist)
                            {
                                minDist = dist;
                            }
                        }


                        for (k = 0; k < pointList.Count; k++)
                        {
                            p = pointList.Keys.ElementAt(k);
                            int dist = manhattanDistance(p, i, j);
                            if (dist == minDist)
                            {
                                lst.Add(k);
                            }
                        }

                        int redNearsCount = 0;
                        int blueNearCounts = 0;
                        for (k = 0; k < lst.Count; k++)
                        {
                            if (pointList.Values.ElementAt(lst.ElementAt(k)) == -1)
                                blueNearCounts++;
                            else
                                redNearsCount++;
                        }

                        points[i, j] = (double)blueNearCounts / (blueNearCounts + redNearsCount);
                        tmpBlue[i] += points[i, j];
                        tmpRed[i] += (1 - points[i, j]);

                    }
                }
            });

            for (int k = 0; k < n; k++)
            {
                redsShare += tmpRed[k];
                bluesShare += tmpBlue[k];

            } 
            
            for (int k = 0; k < pointList.Count; k++)
            {
                if (pointList.Values.ElementAt(k) == -1)
                    bluesShare += 1;
                else
                    redsShare += 1;
            }

            redsShare = Math.Round(redsShare, 10);
            bluesShare = Math.Round(bluesShare, 10);


        }

        public int manhattanDistance(Point p, int i, int j)
        {
            return Math.Abs(i - p.X) + Math.Abs(j - p.Y) - 1;
        }

        public int manhattanDistance(Point p1, Point p2)
        {
            return Math.Abs(p2.X - p1.X) + Math.Abs(p2.X - p1.Y) - 1;
        }

        #endregion

        #region Automatic

        public void findFirstWinPlacementsLimited(int m,int n,out double redsShare,out double bluesShare)    //object sender, DoWorkEventArgs e
        {

            int i = 0;
            int celly = 0, cellx = m / 2;
            int numRedPoints=0, numBluePoints = 0;
            double[,] points = new double[n, m];
            Dictionary<Point, int> pointList = new Dictionary<Point,int>();
            pointList.Clear();
            for (i = 1; i <= numPoints; i++)
            {
                celly = (int)Math.Floor((double)n / (2 * numPoints) + (double)(i - 1) * n / numPoints);
                points[celly, cellx] = -1;
                pointList.Add(new Point(celly, cellx), -1);
                numBluePoints++;
            }
            
            VoronoiRegionSimplified(points, pointList,m,n,out redsShare,out bluesShare);           
            

            int maxLoc = (m) * (n);
            int[] pos = new int[numPoints];
            int[] posInd = new int[numPoints];
            int j;
            lblMinDiff.Text = "";
            lblMinDiff.Refresh();
            StreamWriter sw = new StreamWriter("Result.txt");
            int k = pointList.Count;
            double minDiff = m * n + 1;
            lblMinDiff.Text = "";
            listBox1.Items.Clear();
            string bestSol = "";
            Dictionary<Point, int> d = new Dictionary<Point, int>();
            i = 1;
            bool NoSol = true;
            int t = 0, v = 0, p = 0;
            int[] valids = new int[8 * k];
            v = valids.Length - 1;
            p = pos.Length - 1;
            redsShare =0;
            bluesShare=0;
            double[,] points2 = new double[n,m];
            for (i = 0; i < n; i++)
                for (j = 0; j < m; j++)
                    points2[i, j] = points[i, j];


            for (i = 0; i < numPoints; i++)
            {
                Point bluePoint = pointList.Keys.ElementAt(i);
                valids[t++] = (bluePoint.X - 1) * m + bluePoint.Y - 1;
                valids[t++] = (bluePoint.X - 1) * m + bluePoint.Y;
                valids[t++] = (bluePoint.X - 1) * m + bluePoint.Y + 1;
                valids[t++] = (bluePoint.X) * m + bluePoint.Y - 1;
                valids[t++] = (bluePoint.X) * m + bluePoint.Y + 1;
                valids[t++] = (bluePoint.X + 1) * m + bluePoint.Y - 1;
                valids[t++] = (bluePoint.X + 1) * m + bluePoint.Y;
                valids[t++] = (bluePoint.X + 1) * m + bluePoint.Y + 1;
            }

            Array.Sort(valids);

            for (i = 0; i < numPoints; i++)
            {
                d.Add(pointList.Keys.ElementAt(i), -1);
            }

            for (i = 0; i < numPoints; i++)
            {
                posInd[i] = i;
                pos[i] = valids[i];
            }

            long counter = 0;

            while (pos[0] < valids[v - k + 1])
            {

                counter++;
                d.Clear();

                for (i = 0; i < numPoints; i++)
                {
                    d.Add(pointList.Keys.ElementAt(i), -1);
                }

                for (i = 0; i < numPoints; i++)
                {
                    d.Add(new Point((int)pos[i] / m, pos[i] % m), -2);
                    points2[(int)pos[i] / m, pos[i] % m] = -2;
                }

                redsShare = 0;
                bluesShare = 0;
                numRedPoints = k;
                VoronoiRegionSimplified(points2, d,m,n,out redsShare,out bluesShare);

                if (Math.Abs(redsShare - bluesShare) < minDiff)
                {
                    minDiff = Math.Abs(redsShare - bluesShare);
                    bestSol = "Best Sol ==>|";
                    for (i = 0; i < numPoints - 1; i++)
                    {
                        bestSol += String.Format("({0},{1})-", (int)(pos[i]) / m + 1, pos[i] % m + 1);
                    }
                    bestSol += String.Format("({0},{1})", (int)(pos[numPoints - 1]) / m + 1, pos[numPoints - 1] % m + 1);
                }


                if (redsShare > bluesShare)
                {
                    NoSol = false;
                    string item = " >>> RedsShare:" + redsShare.ToString() + " ---- BluesShare:" + bluesShare.ToString() + " ==>|";
                    sw.Write(item);

                    for (i = 0; i < numPoints - 1; i++)
                    {
                        item += "(" + ((int)pos[i] / m + 1).ToString() + "," + (pos[i] % m + 1).ToString() + ")-";
                    }
                    item += "(" + ((int)pos[numPoints - 1] / m + 1).ToString() + "," + (pos[numPoints - 1] % m + 1).ToString() + ")";
                    sw.WriteLine(item);
                    listBox1.Items.Add(item);
                    listBox1.Refresh();
                }

                if (Math.Abs(bluesShare - redsShare) < ep)
                {
                    NoSol = false;
                    string item = " === RedsShare:" + redsShare.ToString() + " ---- BluesShare:" + bluesShare.ToString() + " ==>|";
                    sw.Write(item);

                    for (i = 0; i < numPoints - 1; i++)
                    {
                        item += "(" + ((int)pos[i] / m + 1).ToString() + "," + (pos[i] % m + 1).ToString() + ")-";
                    }

                    item += "(" + ((int)pos[numPoints - 1] / m + 1).ToString() + "," + (pos[numPoints - 1] % m + 1).ToString() + ")";
                    sw.WriteLine(item);
                    listBox1.Items.Add(item);
                    listBox1.Refresh();
                }

                if (counter % 10000 == 0)
                {
                    label10.Text = counter.ToString();
                    label10.Refresh();
                }
                for (i = 0; i < numPoints; i++)
                {
                    points2[(int)pos[i] / m, pos[i] % m] = 0;
                }

                t = p;
                if (pos[t] >= valids[v])
                {

                    while (pos[t] >= valids[v - (p - t)] && t > 0)
                    {
                        pos[t] = 0;
                        posInd[t] = 0;
                        t--;
                        posInd[t]++;
                        pos[t] = valids[posInd[t]];
                    }

                    for (k = t + 1; k <= p; k++)
                    {
                        posInd[k] = posInd[k - 1] + 1;
                        pos[k] = valids[posInd[k - 1] + 1];
                    }
                }
                else
                {
                    posInd[t]++;
                    pos[t] = valids[posInd[t]];
                }

            }
            
            label10.Text = counter.ToString();
            lblMinDiff.Text = minDiff.ToString() + " ------ " + (Math.Abs(minDiff) == 0).ToString();

            if (NoSol)
            {
                listBox1.Items.Add(bestSol);
                sw.WriteLine("No Win Placement For Red!!!   Best Placement is : " + bestSol);

            }
            sw.Close();
            numRedPoints = 0;
        }


        public void saveWinOrBest(int n, int m, int k)
        {
            if(oleCon.State != System.Data.ConnectionState.Open)
                oleCon.Open();
            oleCom.Connection = oleCon;
            int numItems = listBox1.Items.Count;
            for (int i = 0; i < numItems; i++)
            {
                String sqlStr = String.Format("INSERT INTO WinOrBest (n,m,k,result) VALUES({0},{1},{2},'{3}')",n,m,k,listBox1.Items[i].ToString());
                oleCom.CommandText = sqlStr;
                oleCom.ExecuteNonQuery();
            }
            oleCon.Close();
        }

        public void saveLM(int n, int m, int k)
        {
            if (oleCon.State != System.Data.ConnectionState.Open)
                oleCon.Open();
            oleCom.Connection = oleCon;
            int numItems = listBox1.Items.Count;
            for (int i = 0; i < numItems; i++)
            {
                String sqlStr = String.Format("INSERT INTO LM (n,m,k,result) VALUES({0},{1},{2},'{3}')", n, m, k, listBox1.Items[i].ToString());
                oleCom.CommandText = sqlStr;
                oleCom.ExecuteNonQuery();
            }
            oleCon.Close();
        }

        public void saveWinOrBest(int n, int m, int k,List<String> list)
        {
            if (oleCon.State != System.Data.ConnectionState.Open)
                oleCon.Open();
            oleCom.Connection = oleCon;
            int numItems = list.Count;
            for (int i = 0; i < numItems; i++)
            {
                String sqlStr = String.Format("INSERT INTO WinOrBest (n,m,k,result) VALUES({0},{1},{2},'{3}')", n, m, k, list.ElementAt(i));
                oleCom.CommandText = sqlStr;
                oleCom.ExecuteNonQuery();
            }
            oleCon.Close();
        }

        public void saveLM(int n, int m, int k, List<String> list)
        {
            if (oleCon.State != System.Data.ConnectionState.Open)
                oleCon.Open();
            oleCom.Connection = oleCon;
            int numItems = list.Count;
            for (int i = 0; i < numItems; i++)
            {
                String sqlStr = String.Format("INSERT INTO LM (n,m,k,result) VALUES({0},{1},{2},'{3}')", n, m, k, list.ElementAt(i));
                oleCom.CommandText = sqlStr;
                oleCom.ExecuteNonQuery();
            }
            oleCon.Close();
        }

        public void findFirstWinPlacementsLimited3ForPar(int m, int n, out double redsShare, out double bluesShare)    //object sender, DoWorkEventArgs e
        {

            OleDbCommand oleCom = new OleDbCommand();
            if (useDb)
            {
                if (oleCon.State != System.Data.ConnectionState.Open)
                    oleCon.Open();
                oleCom.Connection = oleCon;
                String sqlStr = String.Format("SELECT result FROM WinOrBest where n={0} and m={1} and k={2}", n, m, numPoints);
                oleCom.CommandText = sqlStr;
                OleDbDataReader oledr = oleCom.ExecuteReader();
                if (oledr.HasRows)
                {
                    
                    oleCon.Close();
                    redsShare = 0;
                    bluesShare = 0;
                    return;
                }
                else
                {
                    oleCon.Close();
                }
            }


            int i = 0;
            int celly = 0, cellx = m / 2;
            int numRedPoints = 0, numBluePoints = 0;
            double[,] points = new double[n, m];
            Dictionary<Point, int> pointList = new Dictionary<Point, int>();
            pointList.Clear();

            for (i = 1; i <= numPoints; i++)
            {
                celly = (int)Math.Floor((double)n / (2 * numPoints) + (double)(i - 1) * n / numPoints);
                points[celly, cellx] = -1;
                pointList.Add(new Point(celly, cellx), -1);
                numBluePoints++;
            }

            VoronoiRegionSimplified(points, pointList, m, n, out redsShare, out bluesShare);


            int[] pos = new int[numPoints];
            int[] posOr = new int[numPoints];
            double bestRed = 0, bestBlue = 0;
            int[] posInd = new int[numPoints];

            int j;
            int k = pointList.Count;
            double minDiff = m * n + 1;
            Dictionary<Point, int> d = new Dictionary<Point, int>();
            List<String> bestSols = new List<String>();
            i = 1;
            bool NoSol = true;
            int t = 0, v = 0, p = 0;
            p = pos.Length - 1;

            double[,] points2 = new double[n, m];
            for (i = 0; i < n; i++)
                for (j = 0; j < m; j++)
                    points2[i, j] = points[i, j];

            int[] shifts = new int[9];

            shifts[0] = -(m - 3 + 4);
            shifts[1] = shifts[0] + 1;
            shifts[2] = shifts[0] + 2;
            shifts[3] = -1;
            shifts[4] = 1;
            shifts[5] = m - 3 + 2;
            shifts[6] = shifts[5] + 1;
            shifts[7] = shifts[6] + 1;
            shifts[8] = 0;

            redsShare = 0;
            bluesShare = 0;
            for (i = 0; i < numPoints; i++)
            {
                d.Add(pointList.Keys.ElementAt(i), -1);
            }

            for (i = 0; i < numPoints; i++)
            {
                posInd[i] = 0;
                Point pointi = d.Keys.ElementAt(i);
                posOr[i] = pointi.X * m + pointi.Y;
                pos[i] = posOr[i] + shifts[posInd[i]]; //valids[i];
            }

            long counter = 0;

            while (true)//pos[0] < valids[v - k + 1])
            {
                d.Clear();

                for (i = 0; i < numPoints; i++)
                {
                    d.Add(pointList.Keys.ElementAt(i), -1);
                }

                for (i = 0; i < numPoints; i++)
                {
                    d.Add(new Point((int)pos[i] / m, pos[i] % m), -2);
                    points2[(int)pos[i] / m, pos[i] % m] = -2;
                }

                redsShare = 0;
                bluesShare = 0;
                numRedPoints = k;
                VoronoiRegionSimplified(points2, d, m, n, out redsShare, out bluesShare);

                if (Math.Abs(redsShare - bluesShare) < minDiff)
                {
                    minDiff = Math.Abs(redsShare - bluesShare);
                    bestSols.Clear();
                    bestRed = redsShare;
                    bestBlue = bluesShare;
                }

                if (Math.Abs(redsShare - bluesShare) == minDiff)
                {
                    String bestSol2 = "Best Sol ==>|";
                    for (i = 0; i < numPoints - 1; i++)
                    {
                        bestSol2 += String.Format("({0},{1})-", (int)(pos[i]) / m + 1, pos[i] % m + 1);
                    }
                    bestSol2 += String.Format("({0},{1})", (int)(pos[numPoints - 1]) / m + 1, pos[numPoints - 1] % m + 1);
                    bestSols.Add(bestSol2);
                }


                
                for (i = 0; i < numPoints; i++)
                {
                    points2[(int)pos[i] / m, pos[i] % m] = 0;
                }


                t = p;
                posInd[t]++;
                if (posInd[t] > 7)
                {

                    while (posInd[t] > 7 && t > 0)
                    {
                        pos[t] = posOr[t] + shifts[0];
                        posInd[t] = 0;
                        t--;
                        posInd[t]++;
                        pos[t] = posOr[t] + shifts[posInd[t]];
                    }

                    if (posInd[0] == 8)
                        break;
                }
                else
                {

                    pos[t] = posOr[t] + shifts[posInd[t]];
                }

            }



            if (NoSol)
            {
                redsShare = bestRed;
                bluesShare = bestBlue;
            }

            saveWinOrBest(n, m, numPoints, bestSols);
            numRedPoints = 0;
        
        }



        public void findFirstWinPlacementsLM(int m,int n,out double redsShare,out double bluesShare)    //object sender, DoWorkEventArgs e
        {
            int i = 0;
            
            if (useDb)
            {
                if (oleCon.State != System.Data.ConnectionState.Open)
                    oleCon.Open();
                oleCom.Connection = oleCon;
                //int numItems = listBox1.Items.Count;
                String sqlStr = String.Format("SELECT result FROM LM where n={0} and m={1} and k={2}", n, m, numPoints);
                oleCom.CommandText = sqlStr;
                OleDbDataReader oledr = oleCom.ExecuteReader();
                listBox1.Items.Clear();
                if (oledr.HasRows)
                {
                    while (oledr.Read())
                    {
                        listBox1.Items.Add(oledr[0].ToString());
                    }
                    oleCon.Close();
                    redsShare = 0;
                    bluesShare = 0;
                    return;
                }
                else
                {
                    oleCon.Close();
                }
            }


            
                long start = DateTime.Now.Ticks;
                int celly = 0, cellx = m / 2;
                int numRedPoints = 0, numBluePoints = 0;
                double[,] points = new double[n, m];
                Dictionary<Point, int> pointList = new Dictionary<Point, int>();
                pointList.Clear();

                for (i = 1; i <= numPoints; i++)
                {
                    celly = (int)Math.Floor((double)n / (2 * numPoints) + (double)(i - 1) * n / numPoints);
                    points[celly, cellx] = -1;
                    pointList.Add(new Point(celly, cellx), -1);
                    numBluePoints++;
                }

                VoronoiRegionSimplified(points, pointList, m, n, out redsShare, out bluesShare);
                this.pointList = pointList;
            
            int[] pos = new int[numPoints];
            int[] posOr = new int[numPoints];
            double bestRed = 0, bestBlue = 0;
            int[] posInd = new int[numPoints];

            int  j;
            lblMinDiff.Text = "";
            lblMinDiff.Refresh();
            int k = this.pointList.Count;
            double minDiff = m * n + 1;
            lblMinDiff.Text = "";
            listBox1.Items.Clear();
            List<String> bestSols = new List<String>();
            Dictionary<Point, int> d = new Dictionary<Point, int>();
            i = 1;
            bool NoSol = true;
            int t = 0, v = 0, p = 0;
            p = pos.Length - 1;
            redsShare = 0;
            bluesShare = 0;
            double[,] points2 = new double[n,m];
            for (i = 0; i < n; i++)
                for (j = 0; j < m; j++)
                    points2[i, j] = points[i, j];

            int[] shifts = new int[9];

            shifts[0] = -(m - 3 + 4);
            shifts[1] = shifts[0] + 1;
            shifts[2] = shifts[0] + 2;
            shifts[3] = -1;
            shifts[4] = 1;
            shifts[5] = m - 3 + 2;
            shifts[6] = shifts[5] + 1;
            shifts[7] = shifts[6] + 1;
            shifts[8] = 0;

            for (i = 0; i < numPoints; i++)
            {
                d.Add(pointList.Keys.ElementAt(i), -1);
            }

            for (i = 0; i < numPoints; i++)
            {
                posInd[i] = 0;
                Point pointi = d.Keys.ElementAt(i);
                posOr[i] = pointi.X * m + pointi.Y;
                pos[i] = posOr[i] + shifts[posInd[i]];
            }

            long counter = 0;

            while (true)
            {
                counter++;
                d.Clear();

                for (i = 0; i < numPoints; i++)
                {
                    d.Add(pointList.Keys.ElementAt(i), -1);
                }

                for (i = 0; i < numPoints; i++)
                {
                    d.Add(new Point((int)pos[i] / m, pos[i] % m), -2);
                    points2[(int)pos[i] / m, pos[i] % m] = -2;
                }

                redsShare = 0;
                bluesShare = 0;
                numRedPoints = k;
                VoronoiRegionSimplified(points2, d,m,n,out redsShare,out bluesShare);

                if (Math.Abs(redsShare - bluesShare) < m)
                {
                    String bestSol2 = "Best Sol ==>|";
                    for (i = 0; i < numPoints - 1; i++)
                    {
                        bestSol2 += String.Format("({0},{1})-", (int)(pos[i]) / m + 1, pos[i] % m + 1);
                    }
                    bestSol2 += String.Format("({0},{1})", (int)(pos[numPoints - 1]) / m + 1, pos[numPoints - 1] % m + 1);
                    bestSols.Add(bestSol2);
                }


                if (redsShare > bluesShare)
                {
                    NoSol = false;
                    string item = " >>> RedsShare:" + redsShare.ToString() + " ---- BluesShare:" + bluesShare.ToString() + " ==>|";

                    for (i = 0; i < numPoints - 1; i++)
                    {
                        item += "(" + ((int)pos[i] / m + 1).ToString() + "," + (pos[i] % m + 1).ToString() + ")-";
                    }
                    item += "(" + ((int)pos[numPoints - 1] / m + 1).ToString() + "," + (pos[numPoints - 1] % m + 1).ToString() + ")";
                    listBox1.Items.Add(item);
                    listBox1.Refresh();
                }

                if (Math.Abs(bluesShare - redsShare) < ep)
                {
                    NoSol = false;
                    string item = " === RedsShare:" + redsShare.ToString() + " ---- BluesShare:" + bluesShare.ToString() + " ==>|";

                    for (i = 0; i < numPoints - 1; i++)
                    {
                        item += "(" + ((int)pos[i] / m + 1).ToString() + "," + (pos[i] % m + 1).ToString() + ")-";
                    }

                    item += "(" + ((int)pos[numPoints - 1] / m + 1).ToString() + "," + (pos[numPoints - 1] % m + 1).ToString() + ")";
                    listBox1.Items.Add(item);
                    listBox1.Refresh();
                }

                if (counter % 10000 == 0)
                {
                    label10.Text = counter.ToString();
                    label10.Refresh();
                }
                
                for (i = 0; i < numPoints; i++)
                {
                    points2[(int)pos[i] / m, pos[i] % m] = 0;
                }


                t = p;
                posInd[t]++;
                if (posInd[t] > 7)
                {

                    while (posInd[t] > 7 && t > 0)
                    {
                        pos[t] = posOr[t] + shifts[0];
                        posInd[t] = 0;
                        t--;
                        posInd[t]++;
                        pos[t] = posOr[t] + shifts[posInd[t]];
                    }

                    if (posInd[0] == 8)
                        break;
                }
                else
                {
                    
                    pos[t] = posOr[t] + shifts[posInd[t]];
                }

            }

            label10.Text = counter.ToString();
            lblMinDiff.Text = minDiff.ToString() + " ------ " + (Math.Abs(minDiff) == 0).ToString();

            if (NoSol)
            {
                for(i=0;i<bestSols.Count;i++)
                    listBox1.Items.Add(bestSols[i]);
                redsShare = bestRed;
                bluesShare = bestBlue;
            }
            numRedPoints = 0;
            saveLM(n, m, numPoints);
        }


        public void findFirstWinPlacementsLimited2(int m, int n, out double redsShare, out double bluesShare)    //object sender, DoWorkEventArgs e
        {
            int i = 0;

            if (useDb && useStategy)
            {

                if (oleCon.State != System.Data.ConnectionState.Open)
                    oleCon.Open();
                oleCom.Connection = oleCon;
                String sqlStr = String.Format("SELECT result FROM WinOrBest where n={0} and m={1} and k={2}", n, m, numPoints);
                oleCom.CommandText = sqlStr;
                OleDbDataReader oledr = oleCom.ExecuteReader();
                listBox1.Items.Clear();
                if (oledr.HasRows)
                {
                    while (oledr.Read())
                    {
                        listBox1.Items.Add(oledr[0].ToString());
                    }
                    oleCon.Close();
                    redsShare = 0;
                    bluesShare = 0;
                    return;
                }
                else
                {
                    oleCon.Close();
                }
            }



            long start = DateTime.Now.Ticks;
            int celly = 0, cellx = m / 2;
            int numRedPoints = 0, numBluePoints = 0;
            double[,] points = new double[n, m];
            Dictionary<Point, int> pointList = new Dictionary<Point, int>();

            if (useStategy)
            {
                pointList.Clear();

                for (i = 1; i <= numPoints; i++)
                {
                    celly = (int)Math.Floor((double)n / (2 * numPoints) + (double)(i - 1) * n / numPoints);
                    points[celly, cellx] = -1;
                    pointList.Add(new Point(celly, cellx), -1);
                    numBluePoints++;
                }

            }
            else
            {
                pointList = this.pointList;
                points = this.points;
            }
            VoronoiRegionSimplified(points, pointList, m, n, out redsShare, out bluesShare);
            int[] pos = new int[numPoints];
            int[] posOr = new int[numPoints];
            double bestRed = 0, bestBlue = 0;
            int[] posInd = new int[numPoints];

            int j;
            lblMinDiff.Text = "";
            lblMinDiff.Refresh();
            int k = this.pointList.Count;
            double minDiff = m * n + 1;
            lblMinDiff.Text = "";
            listBox1.Items.Clear();
            List<String> bestSols = new List<String>();
            Dictionary<Point, int> d = new Dictionary<Point, int>();
            i = 1;
            bool NoSol = true;
            int t = 0, v = 0, p = 0;
            p = pos.Length - 1;
            redsShare = 0;
            bluesShare = 0;
            double[,] points2 = new double[n, m];
            for (i = 0; i < n; i++)
                for (j = 0; j < m; j++)
                    points2[i, j] = points[i, j];

            int[] shifts = new int[9];

            shifts[0] = -(m - 3 + 4);
            shifts[1] = shifts[0] + 1;
            shifts[2] = shifts[0] + 2;
            shifts[3] = -1;
            shifts[4] = 1;
            shifts[5] = m - 3 + 2;
            shifts[6] = shifts[5] + 1;
            shifts[7] = shifts[6] + 1;
            shifts[8] = 0;

            for (i = 0; i < numPoints; i++)
            {
                d.Add(pointList.Keys.ElementAt(i), -1);
            }

            for (i = 0; i < numPoints; i++)
            {
                posInd[i] = 0;
                Point pointi = d.Keys.ElementAt(i);
                posOr[i] = pointi.X * m + pointi.Y;
                pos[i] = posOr[i] + shifts[posInd[i]];
            }

            long counter = 0;

            while (true)
            {
                counter++;
                d.Clear();

                for (i = 0; i < numPoints; i++)
                {
                    d.Add(pointList.Keys.ElementAt(i), -1);
                }

                for (i = 0; i < numPoints; i++)
                {
                    d.Add(new Point((int)pos[i] / m, pos[i] % m), -2);
                    points2[(int)pos[i] / m, pos[i] % m] = -2;
                }

                redsShare = 0;
                bluesShare = 0;
                numRedPoints = k;
                VoronoiRegionSimplified(points2, d, m, n, out redsShare, out bluesShare);

                if (Math.Abs(redsShare - bluesShare) < minDiff)
                {
                    minDiff = Math.Abs(redsShare - bluesShare);
                    bestSols.Clear();
                    bestRed = redsShare;
                    bestBlue = bluesShare;
                }

                if (Math.Abs(redsShare - bluesShare) == minDiff)
                {
                    String bestSol2 = "Best Sol ==>|";
                    for (i = 0; i < numPoints - 1; i++)
                    {
                        bestSol2 += String.Format("({0},{1})-", (int)(pos[i]) / m + 1, pos[i] % m + 1);
                    }
                    bestSol2 += String.Format("({0},{1})", (int)(pos[numPoints - 1]) / m + 1, pos[numPoints - 1] % m + 1);
                    bestSols.Add(bestSol2);
                }


                if (redsShare > bluesShare)
                {
                    NoSol = false;
                    string item = " >>> RedsShare:" + redsShare.ToString() + " ---- BluesShare:" + bluesShare.ToString() + " ==>|";

                    for (i = 0; i < numPoints - 1; i++)
                    {
                        item += "(" + ((int)pos[i] / m + 1).ToString() + "," + (pos[i] % m + 1).ToString() + ")-";
                    }
                    item += "(" + ((int)pos[numPoints - 1] / m + 1).ToString() + "," + (pos[numPoints - 1] % m + 1).ToString() + ")";
                    listBox1.Items.Add(item);
                    listBox1.Refresh();
                }

                if (Math.Abs(bluesShare - redsShare) < ep)
                {
                    NoSol = false;
                    string item = " === RedsShare:" + redsShare.ToString() + " ---- BluesShare:" + bluesShare.ToString() + " ==>|";

                    for (i = 0; i < numPoints - 1; i++)
                    {
                        item += "(" + ((int)pos[i] / m + 1).ToString() + "," + (pos[i] % m + 1).ToString() + ")-";
                    }

                    item += "(" + ((int)pos[numPoints - 1] / m + 1).ToString() + "," + (pos[numPoints - 1] % m + 1).ToString() + ")";
                    listBox1.Items.Add(item);
                    listBox1.Refresh();
                }

                if (counter % 10000 == 0)
                {
                    label10.Text = counter.ToString();
                    label10.Refresh();
                }

                for (i = 0; i < numPoints; i++)
                {
                    points2[(int)pos[i] / m, pos[i] % m] = 0;
                }


                t = p;
                posInd[t]++;
                if (posInd[t] > 7)
                {

                    while (posInd[t] > 7 && t > 0)
                    {
                        pos[t] = posOr[t] + shifts[0];
                        posInd[t] = 0;
                        t--;
                        posInd[t]++;
                        pos[t] = posOr[t] + shifts[posInd[t]];
                    }

                    if (posInd[0] == 8)
                        break;
                }
                else
                {

                    pos[t] = posOr[t] + shifts[posInd[t]];
                }

            }

            label10.Text = counter.ToString();
            lblMinDiff.Text = minDiff.ToString() + " ------ " + (Math.Abs(minDiff) == 0).ToString();

            if (NoSol)
            {
                for (i = 0; i < bestSols.Count; i++)
                    listBox1.Items.Add(bestSols[i]);
                redsShare = bestRed;
                bluesShare = bestBlue;
            }
            numRedPoints = 0;
            if (useDb && useStategy)
                saveWinOrBest(n, m, numPoints);
        }

        public void findFirstWinPlacements(int m,int n,out double redsShare,out double bluesShare)    //object sender, DoWorkEventArgs e
        {
            int i = 0;

            double[,] points = new double[n, m];
            Dictionary<Point, int> pointList = new Dictionary<Point, int>();

            if (useStategy)
            {
                int celly = 0, cellx = m / 2;
                int numRedPoints = 0, numBluePoints = 0;
            
                pointList.Clear();

                for (i = 1; i <= numPoints; i++)
                {
                    celly = (int)Math.Floor((double)n / (2 * numPoints) + (double)(i - 1) * n / numPoints);
                    points[celly, cellx] = -1;
                    pointList.Add(new Point(celly, cellx), -1);
                    numBluePoints++;
                }
            }
            else{
                pointList = this.pointList;
                points = this.points;
            }
            VoronoiRegionSimplified(points, pointList,m,n,out redsShare,out bluesShare);           
            
            int maxLoc = (m) * (n);
            int[] pos = new int[numPoints];
            int[] posInd = new int[numPoints];
            int j;
            lblMinDiff.Text = "";
            lblMinDiff.Refresh();
            StreamWriter sw = new StreamWriter("Result.txt");
            int k = pointList.Count;
            double minDiff = m * n + 1;
            lblMinDiff.Text = "";
            listBox1.Items.Clear();
            string bestSol = "";
            Dictionary<Point, int> d = new Dictionary<Point, int>();
            i = 1;
            bool NoSol = true;
            int t = 0, v = 0, p = 0;
            int[] valids = new int[m * n - k];
            v = valids.Length - 1;
            p = pos.Length - 1;
            redsShare=0;
            bluesShare=0;
            double[,] points2 = new double[n,m];
            for (i = 0; i < n; i++)
            {
                for (j = 0; j < m; j++)
                {
                    points2[i, j] = points[i, j];
                    if (points[i, j] >= 0)
                    {
                        valids[t] = i * m + j;
                        t++;
                    }
                }
            }

            for (i = 0; i < numPoints; i++)
            {
                d.Add(pointList.Keys.ElementAt(i), -1);
            }

            for (i = 0; i < numPoints; i++)
            {
                posInd[i] = i;
                pos[i] = valids[i];
            }

            long counter = 0;

            while (pos[0] < valids[v - k + 1])
            {
                counter++;
                d.Clear();

                for (i = 0; i < numPoints; i++)
                {
                    d.Add(pointList.Keys.ElementAt(i), -1);
                }

                for (i = 0; i < numPoints; i++)
                {
                    d.Add(new Point((int)pos[i] / m, pos[i] % m), -2);
                    points2[(int)pos[i] / m, pos[i] % m] = -2;
                }

                redsShare = 0;
                bluesShare = 0;
                numRedPoints = k;
                VoronoiRegionSimplified(points2, d,m,n,out redsShare,out bluesShare);
                if (Math.Abs(redsShare - bluesShare) < minDiff)
                {
                    minDiff = Math.Abs(redsShare - bluesShare);
                    bestSol = "Best Sol ==>|";
                    for (i = 0; i < numPoints - 1; i++)
                    {
                        bestSol += String.Format("({0},{1})-", (int)(pos[i]) / m + 1, pos[i] % m + 1);
                    }
                    bestSol += String.Format("({0},{1})", (int)(pos[numPoints - 1]) / m + 1, pos[numPoints - 1] % m + 1);
                }
                if (redsShare > bluesShare)
                {
                    NoSol = false;
                    string item = " >>> RedsShare:" + redsShare.ToString() + " ---- BluesShare:" + bluesShare.ToString() + " ==>|";
                    sw.Write(item);

                    for (i = 0; i < numPoints - 1; i++)
                    {
                        item += "(" + ((int)pos[i] / m + 1).ToString() + "," + (pos[i] % m + 1).ToString() + ")-";
                    }
                    item += "(" + ((int)pos[numPoints - 1] / m + 1).ToString() + "," + (pos[numPoints - 1] % m + 1).ToString() + ")";
                    sw.WriteLine(item);
                    listBox1.Items.Add(item);
                    listBox1.Refresh();
                }

                if (Math.Abs(bluesShare - redsShare) < ep)
                {
                    NoSol = false;
                    string item = " === RedsShare:" + redsShare.ToString() + " ---- BluesShare:" + bluesShare.ToString() + " ==>|";
                    sw.Write(item);

                    for (i = 0; i < numPoints - 1; i++)
                    {
                        item += "(" + ((int)pos[i] / m + 1).ToString() + "," + (pos[i] % m + 1).ToString() + ")-";
                    }

                    item += "(" + ((int)pos[numPoints - 1] / m + 1).ToString() + "," + (pos[numPoints - 1] % m + 1).ToString() + ")";
                    sw.WriteLine(item);
                    listBox1.Items.Add(item);
                    listBox1.Refresh();
                }

                if (counter % 10000 == 0)
                {
                    label10.Text = counter.ToString();
                    label10.Refresh();
                }
                for (i = 0; i < numPoints; i++)
                {
                    points2[(int)pos[i] / m, pos[i] % m] = 0;
                }

                t = p;
                if (pos[t] >= valids[v])
                {

                    while (pos[t] >= valids[v - (p - t)] && t > 0)
                    {
                        pos[t] = 0;
                        posInd[t] = 0;
                        t--;
                        posInd[t]++;
                        pos[t] = valids[posInd[t]];
                    }

                    for (k = t + 1; k <= p; k++)
                    {
                        posInd[k] = posInd[k - 1] + 1;
                        pos[k] = valids[posInd[k - 1] + 1];
                    }
                }
                else
                {
                    posInd[t]++;
                    pos[t] = valids[posInd[t]];
                }

            }
            label10.Text = counter.ToString();
            lblMinDiff.Text = minDiff.ToString() + " ------ " + (Math.Abs(minDiff) == 0).ToString();

            if (NoSol)
            {
                listBox1.Items.Add(bestSol);
                sw.WriteLine("No Win Placement For Red!!!   Best Placement is : " + bestSol);

            }

            sw.Close();
            numRedPoints = 0;
        }
        #endregion

        #region Controls

        private void button1_Click(object sender, EventArgs e)
        {
            
            button1.Enabled = false;
            findFirstWinPlacements(m, n, out redsShare, out bluesShare);//null, null);
            button1.Enabled = true;
            button1.Focus();
        }

        private void txtM_TextChanged(object sender, EventArgs e)
        {

        }

        public int M
        {
            get
            {
                if (txtM.Text.Length == 0)
                    return 1;
                else
                    return int.Parse(txtM.Text);
            }
            set
            {
                txtM.Text=value.ToString();
            }
        }

        public int N
        {
            get
            {
                if (txtN.Text.Length == 0)
                    return 1;
                else
                    return int.Parse(txtN.Text);
            }
            set
            {
                txtN.Text=value.ToString();
            }
        }

        public int K
        {
            get
            {
                if (txtNumPoints.Text.Length == 0)
                    return 1;
                else
                    return int.Parse(txtNumPoints.Text);
            }
            set
            {
                txtNumPoints.Text=value.ToString();
            }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            lblMinDiff.Text = "";
            int i = 0;
            m = int.Parse(txtM.Text);
            int celly = 0, cellx = m / 2;
            listBox1.Items.Clear();
            CreateGrid();
            for (i = 1; i <= numPoints; i++)
            {
                celly = (int)Math.Floor((double)n / (2 * numPoints) + (double)(i - 1) * n / numPoints);
                points[celly, cellx] = -1;
                g.FillRectangle(whiteBrush, cellx * step, celly * step, step, step);
                g.DrawEllipse(blackPen, cellx * step + 4, celly * step + 4, step - 10, step - 10);
                pointList.Add(new Point(celly, cellx), -1);
                VoronoiRegion(points, pointList, m, n, out redsShare, out bluesShare);
                numBluePoints++;
            }
            pictureBox1.Refresh();
            lblMinDiff.Text = (bluesShare - redsShare).ToString();
        }

        private void listBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            
            
            
            if (listBox1.SelectedIndex < 0)
                return;

            int i = 0;
            while(i < pointList.Count)
            {
                if (pointList.Values.ElementAt(i) == -2)
                {
                    points[pointList.Keys.ElementAt(i).X, pointList.Keys.ElementAt(i).Y] = 0;
                    pointList.Remove(pointList.Keys.ElementAt(i));
                }
                else
                    i++;
            }

            String text = listBox1.SelectedItem.ToString().Split('|')[1];
            
            String[] strPoints = text.Split('-');
            Point tmpPoints = new Point();
            for (i = 0; i < strPoints.Length; i++)
            {

                string[] parts = (strPoints[i].Substring(1, strPoints[i].Length - 2)).Split(',');
                tmpPoints = new Point(int.Parse(parts[0]) - 1, int.Parse(parts[1]) - 1);
                pointList.Add(tmpPoints, -2);
                points[tmpPoints.X, tmpPoints.Y] = -2;
                
                g.FillRectangle(whiteBrush, tmpPoints.Y * step, tmpPoints.X * step, step, step);
                g.FillEllipse(blackBrush, tmpPoints.Y * step + 4, tmpPoints.X * step + 4, step - 10, step - 10);
            }
            numRedPoints = numPoints;
            VoronoiRegion(points, pointList,m,n,out redsShare,out bluesShare);
            pictureBox1.Refresh();
            lblMinDiff.Text = (bluesShare - redsShare).ToString();

        }

        private void btnSimple_Click(object sender, EventArgs e)
        {
            btnSimple.Enabled = false;
            findFirstWinPlacementsLimited(M,N,out redsShare,out bluesShare);
            btnSimple.Enabled = true;
            btnSimple.Focus();
        }

        private void btnSimple2_Click(object sender, EventArgs e)
        {
            btnSimple2.Enabled = false;
            numPoints = K;
            findFirstWinPlacementsLimited2(M,N,out redsShare,out bluesShare);
            btnSimple2.Enabled = true;
            btnSimple2.Focus();
        }

        private void btnDiagram_Click(object sender, EventArgs e)
        {

            btnDiagram.Enabled = false;
            btnDiagram.Focus();
            draw();

            btnDiagram.Enabled = true;
            btnDiagram.Focus();

        }

        private void btnDiagram_Leave(object sender, EventArgs e)
        {
            if (oleCon.State == System.Data.ConnectionState.Open)
            {
                oleCon.Close();
                oleCon.Dispose();
            }
        }

        private void btnSimple3_Click(object sender, EventArgs e)
        {
            btnSimple3.Enabled = false;
            findFirstWinPlacementsLM(M, N, out redsShare, out bluesShare);
            btnSimple3.Enabled = true;
            btnSimple3.Focus();
        }
        #endregion

        private void mkk_Click(object sender, EventArgs e)
        {
            N = M * K - K + 1;
        }

        private void btnPreM_Click(object sender, EventArgs e)
        {
            M = M - 2;
        }

        private void btnNexM_Click(object sender, EventArgs e)
        {
            M = M + 2;
        }

        private void btnPreN_Click(object sender, EventArgs e)
        {
            N = N - 1;
        }

        private void btnNexN_Click(object sender, EventArgs e)
        {
            N = N + 1;
        }

        private void btnPreK_Click(object sender, EventArgs e)
        {
            K = K - 1;
        }

        private void btnNexK_Click(object sender, EventArgs e)
        {
            K = K + 1;
        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox1.Checked)
            {
                useDb = true;
            }
            else
            
            {
                useDb = false;
            }
        }

        private void checkBox2_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox2.Checked)
            {
                useStategy = true;
            }
            else
            {
                useStategy = false;
            }
        }

        private void mdiff_Click(object sender, EventArgs e)
        {
            N = (int)Math.Floor((double)(5*M*K/3 - 7*K/3));

        }

        #region CommentedCode
        
        #endregion
    }
}
